#ifndef __ARCANA_LISP_SYNTAX_H__
#define __ARCANA_LISP_SYNTAX_H__

#include "object.h"

/*******************************************
 * Special syntax to use in the executable *
 *******************************************/

struct Object *syntax_repl(struct Object *args, struct Object *environment);
struct Object *syntax_script(struct Object *args, struct Object *environment);

/*******************
 * Syntax keywords *
 *******************/

struct Object *syntax_begin(struct Object *args, struct Object *environment);
struct Object *syntax_cond(struct Object *args, struct Object *environment);
struct Object *syntax_define(struct Object *args, struct Object *environment);
struct Object *syntax_if(struct Object *args, struct Object *environment);
struct Object *syntax_lambda(struct Object *args, struct Object *environment);
struct Object *syntax_let(struct Object *args, struct Object *environment);
struct Object *syntax_quote(struct Object *args, struct Object *environment);

#endif
